Page MenuHome

Quick Favorites: add support for operator/prop enums (e.g. "Set origin")
Open, Confirmed, MediumPublic

Description

System Information
Operating system: Windows 10
Graphics card: Nvidia GTX1080

Blender Version
Broken: 2.80, 16fc62e15f0, blender2.8, 2018-12-12
Worked: 3d92afca7eb

Short description of error
The Set origin menu is not possible to put into quic favourites.

Exact steps for others to reproduce the error
3dView -> Object menu -> Right click on "Set origin..." -> empty menu.

Details

Type
To Do

Related Objects

Event Timeline

Jacques Lucke (JacquesLucke) lowered the priority of this task from Needs Triage by Developer to Confirmed, Medium.Dec 12 2018, 3:26 PM

Can confirm.

I see two problems here:

  • Right clicking on operator_menu_enum brings up an empty menu.
  • Right clicking on a menu entry while the menu is open, does not open the right-click-menu at all.
Philipp Oeser (lichtwerk) claimed this task.

This seems to be fixed, no?

Havent hunted down the relating commit, but as of today I am getting the menu (and choosing the entry will add it to the favorites OK)

Closing (but feel free to comment again/reopen if issues persist...)

I thought it's about this menu, which does not seem to be fixed yet:

Ah, OK, will check on this, too...

Philipp Oeser (lichtwerk) renamed this task from Set origin command not possible to put in quick favourites to Quick Favorites: operator/prop enums (e.g. "Set origin") cannot be added.Jan 8 2019, 11:02 AM

As merged from a report I previously made was relating to a slightly different though closely related issue.

some screenshots;-

these are missing in 2019-01-11 - 1c7695b8483d and all previously downloaded versions.

Campbell Barton (campbellbarton) renamed this task from Quick Favorites: operator/prop enums (e.g. "Set origin") cannot be added to Quick Favorites: add support for operator/prop enums (e.g. "Set origin").May 9 2019, 9:51 AM
Campbell Barton (campbellbarton) lowered the priority of this task from Confirmed, Medium to Confirmed, Low.
Campbell Barton (campbellbarton) changed Type from Bug to To Do.

Support for this can be added but this is more of a TODO, added to T63726: User Interface Module

Super sorry for adding yet another duplicate to this list. I did check for it but I guess not good enough.

Philipp Oeser (lichtwerk) raised the priority of this task from Confirmed, Low to Confirmed, Medium.Aug 7 2019, 2:56 PM

I hear you, hope to get to it soon...

Hi I would like to contribute towards this I have narrowed down the files to interface_context_menu.c and interface_handlers.c , at least I believe these are to be modified, what I don't understand is when we right-click on any of the options what function is called or is it generic that on right-clicking "Add/remove Quick favorites" will appear ? Like it working for "Transform" and all the others in the Add menu, where should I start looking, any hints or suggestions would be great. Thanks

will get back to you Monday (I am away over the WE)

Atm. Quick Favorites only works for:

What we are looking for is a way to handle operator enum menus.
These are just not covered by current design (see above), and quite some stuff need to be added [even then I am not sure if all would work out fine -- this is just quick speculation how this could work]:

  • would probably need something new like bUserMenuItem_OpEnumMenu [next to existing bUserMenuItem_Prop, bUserMenuItem_Menu, bUserMenuItem_Op] that needs to store at least op_idname (maybe more, would needto check more...)
  • incorporate this into ui_but_is_user_menu_compatible (so it doesnt get skipped in ui_popup_context_menu_for_button)
  • (atm. UI_but_menutype_get does this for 'real' menus, would need something like UI_but_openummenu_ok or something like that)
  • (investigation of ui_item_menutype_func vs. menu_item_enum_opname_menu and UI_BTYPE_BUT_MENU vs. UI_BTYPE_PULLDOWN might also help)
  • now onto actual insertion into bUserMenu (!warning! gets even more speculative):
    • happens in popup_user_menu_add_or_replace_func / ui_but_user_menu_add
    • ED_screen_user_menu_item_add_menu does this for 'real' menus, would need something doing this based on the new bUserMenuItem_OpEnumMenu
  • now if that is sucessfully stored bUserMenu
    • add another - new - case in screen_user_menu_draw which correctly generates the menu to click on here
  • also note: above new struct would also need to be taken care of in write_userdef (I assume)

@Himanshi Kalra (calra): this is not the easiest task to pick up, I am still willing to look at this myself (but triaging the tracker unfortunately takes all of my time atm. so help is definitely appreciated)
(please also take all of the above with a grain of salt, there might be other/better ways to do this -- this is just how I had it lying around in my head for a while...)
I will also step down as a assignee from this task (as we moved from assignments to people in favor of having the modules look at the corresponding bugs...)

Thanks @Philipp Oeser (lichtwerk) for the input, I will look into it for some time and will let you know if I have any success, from a holistic view I speculated that this and T64365 would be related, as the problem seemed similar. To be honest currently some of the stuff is bouncing off, I can try for some time to implement what you suggested.

My most missed that still don't work as of 2.82 Alpha are the Object > Convert to and Object > Set Origin, most other are apparently working.